Subject: Re: [PATCH v4 net-next 1/5] ethtool: Add support for configuring tx_push_buf_len

From: Jakub Kicinski <[email-masked]>
Date: Thu, 9 Mar 2023 22:53:26 -0800

On Thu, 9 Mar 2023 19:15:43 +0200 Gal Pressman wrote:
> I know Jakub prefers the new parameter, but the description of this
> still sounds extremely similar to TX copybreak to me..
> TX copybreak was traditionally used to copy packets to preallocated DMA
> buffers, but this could be implemented as copying the packet to the
> (preallocated) WQE's inline part. That usually means DMA memory, but
> could also be device memory in this ENA LLQ case.
> 
> Are we drawing a line that TX copybreak is the threshold for DMA memory
> and tx_push_buf_len is the threshold for device memory?

Pretty much, yes. Not an amazing distinction but since TX copybreak can
already mean two different things (inline or DMA buf) I'd err on 
the side of not overloading it with another one. 
And Pensando needed a similar knob? Maybe I'm misremembering now.

> Are they mutually exclusive?

Not sure.

> BTW, as I mentioned in v1, ENA doesn't advertise tx_push, which is a bit
> strange given the fact that it now adds tx_push_buf_len support.

Fair point.